Subject: IPP> Required IPP attributes - missing list anywhere

From: "Ira McDonald" <[email-masked]>
Date: Mon, 21 Jul 2008 17:39:00 -0400

Hi,

Paul Tykodi's asked at today's IPP WG telecon how to find
the list of required IPP/1.1 attributes (i.e., ones that all IPP/1.1
Printer objects MUST support).

I said (incorrectly) that this was listed in the IPP Registry, but
sadly it's not.  There is no such single list.  In all IPP specs,
the required attributes are documented (but not very well).
For basic IPP/1.1 (RFC 2911), they are listed at:

- Section 3.1.4.1 Request Operation Attributes - page 25
  - attributes-charset and attributes-natural-language
- Section 3.1.4.2 Response Operation Attributes - page 29
  - attributes-charset and attributes-natural-language
- Section 3.2  Printer Operations
  - some REQUIRED operation attributes
- Section 3.3  Job Operations
  - some REQUIRED operation attributes
- Section 4.2 Job Template Attributes - page 91
  - all OPTIONAL
- Section 4.3 Job Description Attributes - page 106
  - see table
- Section 4.4 Printer Description Attributes - page 124
  - see table

All - I think Paul's raised a good point - the list of basic
IPP/1.1 (and therefore IPP/2.0) REQUIRED operation
and description attributes does NOT exist - Should it
be added in a normative appendix to the IPP/2.0 spec?

The IANA IPP Registry (complete for all IETF RFCs but
not for any PWG IPP Extensions) is at:

  http://www.iana.org/assignments/ipp-registrations
  (a plaintext file)

Cheers,
- Ira

-- 
Ira McDonald (Musician / Software Architect)
Chair - Linux Foundation Open Printing WG
Blue Roof Music/High North Inc
email: [email-masked]
winter:
 579 Park Place Saline, MI 48176
 734-944-0094
summer:
 PO Box 221 Grand Marais, MI 49839
 906-494-2434

---

From: Michael R Sweet <[email-masked]>
Date: Mon, 21 Jul 2008 14:55:34 -0700

Ira McDonald wrote:
> ...

Yes, absolutely.  In fact, I would add a section for IPP/2.1 and
IPP/2.2 as well.

-- 
______________________________________________________________________
Michael R Sweet                        Senior Printing System Engineer

---

From: "Ira McDonald" <[email-masked]>
Date: Mon, 21 Jul 2008 19:29:10 -0400

Hi Mike,

I agree we need required attributes lists for IPP 2.0, 2.1, and 2.2.

Which means we need some help as editors.  Because it's going
to take a *long* time to search through the text of every IPP spec
looking for the keyword REQUIRED in the body text for attributes
(such as operation attributes) that are nowhere else mentioned.

Mike, Ted, Bill, anyone - care to volunteer to help?

Cheers,
- Ira

---

From: Michael R Sweet <[email-masked]>
Date: Mon, 21 Jul 2008 16:34:59 -0700

> Mike, Ted, Bill, anyone - care to volunteer to help?

I'll sift through 2911.

---

From: "Ira McDonald" <[email-masked]>
Date: Mon, 21 Jul 2008 19:50:50 -0400

Hi Mike,

Great - thanks for the help!

By the way, the IANA Registry *does* contain a complete list of IETF spec
IPP attributes *with* source document and section references - starting with
that list (just adding a REQ/OPT column) would hopefully ensure that we
don't miss any IANA-registered ones.

Harry Lewis and I have a somewhat ancient action item from PWG Steering
Committee to gather up the IANA registrations (for attributes, operations,
objects, etc.) from all the PWG specs - fortunately (for Harry and I), the
IANA and IETF process people haven't been answering their mail (smile).

Jerry Thrasher plans to talk to IETF Area Directors and IANA folks in
person next week at IETF 72 in Dublin, Ireland and get some progress on
IANA IPP and IANA Printer MIB registries.

Cheers,
- Ira